#!/usr/bin/perl -w

# Version 0.4 bwdezend
#  9/22/2009

use strict;
use Getopt::Long;

my $hostAddress;
my $warn   = 100;
my $crit   = 50;
my $value  = 0;
my $status = 'UNKNOWN';

&Getopt::Long::Configure( 'pass_through', 'no_autoabbrev');
&Getopt::Long::GetOptions(
	'warn|w=i'			=> \$warn,
	'crit|critical|c=i'		=> \$crit,
);

#these won't get tripped unless you unset the initial values (my $warn = 80, above) AND
# fail to set them on the command line.
unless ($warn) {&exit_with_status('ERROR: No warning threshold specified', 'UNKNOWN')};
unless ($crit) {&exit_with_status('ERROR: No critical threshold specified', 'UNKNOWN')};

#do the actual check here.

my $finish    = time();
my $start_1   = $finish - 60;
my $start_5   = $finish - 300;
my $start_15  = $finish - 900;
my $count_1   = undef;
my $count_5   = undef;
my $count_15  = undef;

unless(open(LOG, "< /local/nagios/var/nagios.log")){die "Cannot open $!\n"}

while (my $line = <LOG>){
        unless ($line =~ m/EXTERNAL COMMAND/){next}
        if ($line =~ m/\[(\d+)\]/){
                if ($1 >= $start_1){$count_1++}
                if ($1 >= $start_5){$count_5++}
                if ($1 >= $start_15){$count_15++}
        }

}

$value = $count_5;


#eval statements, set plugin return status
if ($value >= $warn){$status = 'OK'};
if ($value <= $warn){$status = 'WARNING'};
if ($value <= $crit){$status = 'CRITICAL'};

&exit_with_status('Nagios External Checks Processes', $status);

sub exit_with_status {
	#print out the single line of nagios command output, with perfdata 
	if ($_[1] eq 'UNKNOWN')   {print "$status - $_[0]\n"; exit 3};
	print "$status - $_[0]: $value Checks in the last 5 min | 1min=$count_1;$warn;$crit,5min=$count_5;$warn;$crit,15min=$count_15;$warn;$crit\n";
	if ($_[1] eq 'CRITICAL')  {exit 2};
	if ($_[1] eq 'WARNING')   {exit 1};
	if ($_[1] eq 'OK')        {exit 0};
}
